commit 967b6b0514bcea2f3eeff7300fda73884fbfd16a
Author: horkmi <horkmi@students.zcu.cz>
Date:   Thu May 7 16:48:56 2020 +0200

    re #7893
    
    Refactoring defaultního a IO package + Javadoc.

diff --git a/javadoc/package-list b/javadoc/package-list
new file mode 100644
index 0000000..6251f78
--- /dev/null
+++ b/javadoc/package-list
@@ -0,0 +1,3 @@
+
+io
+jdeserialize
diff --git a/javadoc/script.js b/javadoc/script.js
new file mode 100644
index 0000000..b346356
--- /dev/null
+++ b/javadoc/script.js
@@ -0,0 +1,30 @@
+function show(type)
+{
+    count = 0;
+    for (var key in methods) {
+        var row = document.getElementById(key);
+        if ((methods[key] &  type) != 0) {
+            row.style.display = '';
+            row.className = (count++ % 2) ? rowColor : altColor;
+        }
+        else
+            row.style.display = 'none';
+    }
+    updateTabs(type);
+}
+
+function updateTabs(type)
+{
+    for (var value in tabs) {
+        var sNode = document.getElementById(tabs[value][0]);
+        var spanNode = sNode.firstChild;
+        if (value == type) {
+            sNode.className = activeTableTab;
+            spanNode.innerHTML = tabs[value][1];
+        }
+        else {
+            sNode.className = tableTab;
+            spanNode.innerHTML = "<a href=\"javascript:show("+ value + ");\">" + tabs[value][1] + "</a>";
+        }
+    }
+}
diff --git a/project/Deserializer/src/CLI.java b/project/Deserializer/src/CLI.java
index 74835f5..994850f 100644
--- a/project/Deserializer/src/CLI.java
+++ b/project/Deserializer/src/CLI.java
@@ -5,23 +5,48 @@ import java.util.HashMap;
 import io.FileWorker;
 import javafx.application.Application;
 
+/**
+ * Command-line user interface.
+ */
 public class CLI implements IConversionResults {
 
+	/**
+	 * Instances of this class define options for running the application.
+	 */
 	private static class Option {
+
+		/**
+		 * Abbreviation for the option name.
+		 */
 		String abbr;
+
+		/**
+		 * Text describing the activity for the option.
+		 */
 		String about;
 
+		/**
+		 * Converts an input argument to the option for comparison with options in the
+		 * list.
+		 * 
+		 * @param abbr input argument.
+		 */
 		public Option(String abbr) {
-			// Convert input argument to option.
 			this.abbr = abbr;
 			this.about = null;
 		}
-		
+
+		/**
+		 * Creates an option to the option list.
+		 * 
+		 * @param abbr  option abbreviation.
+		 * @param about option description.
+		 */
 		public Option(String abbr, String about) {
 			this.abbr = abbr;
 			this.about = about;
 		}
-		
+
 		@Override
 		public String toString() {
 			return abbr + "\t" + about;
@@ -48,12 +73,24 @@ public class CLI implements IConversionResults {
 		}
 	}
 
-	
-	
+	/**
+	 * The list of options for running the application.
+	 */
 	private static HashMap<Option, Runnable> options;
+
+	/**
+	 * Whether the resulting JSON should be written to the command line.
+	 */
 	private static boolean printJSON;
+
+	/**
+	 * Where to save the resulting JSON.
+	 */
 	private static File outputFile;
 
+	/**
+	 * Initialization of static variables.
+	 */
 	static {
 		options = new HashMap<Option, Runnable>();
 		options.put(new Option("-?", "\tPrint this help message."), () -> {
@@ -68,32 +105,31 @@ public class CLI implements IConversionResults {
 		printJSON = false;
 	}
 
+	/**
+	 * Prints help for running the application.
+	 */
 	private static void help() {
-		System.out.println("\n"
-				+ "Usage:" + "\n"
-				+ "    java ... -jar JOU_Deserializer.jar [-options] [args...]" + "\n"
-				+ "\n"
-				+ "...:" + "\n"
+		System.out.println("\n" + "Usage:" + "\n" + "    java ... -jar JOU_Deserializer.jar [-options] [args...]" + "\n"
+				+ "\n" + "...:" + "\n"
 				+ "    When running the app in the JVM 11, the following VM arguments may be required:" + "\n"
-				+ "        --module-path libs\\javafx-sdk-11.0.2\\lib --add-modules=javafx.controls" + "\n"
-				+ "\n"
-				+ "-options:" + "\n"
-				+ printOptions()
-				+ "\n"
-				+ "args...:" + "\n"
+				+ "        --module-path libs\\javafx-sdk-11.0.2\\lib --add-modules=javafx.controls" + "\n" + "\n"
+				+ "-options:" + "\n" + printOptions() + "\n" + "args...:" + "\n"
 				+ "    Input and output file. Output file need not be specified, if options contains -print." + "\n"
-				+ "\n"
-				+ "Note: if no options and arguments are specified, the GUI is created." + "\n"
-				+ "\n"
-				+ "Example:" + "\n"
-				+ "    CLI: java -jar JOU_Deserializer.jar -print input.data output.json" + "\n"
+				+ "\n" + "Note: if no options and arguments are specified, the GUI is created." + "\n" + "\n"
+				+ "Example:" + "\n" + "    CLI: java -jar JOU_Deserializer.jar -print input.data output.json" + "\n"
 				+ "    GUI: java -jar JOU_Deserializer.jar" + "\n");
 	}
-	
+
+	/**
+	 * Sets printJSON to true.
+	 */
 	private static void setPrintJSON() {
 		printJSON = true;
 	}
-	
+
+	/**
+	 * @return string with all possible options for running the application.
+	 */
 	private static String printOptions() {
 		String result = "";
 		for (Option option : options.keySet()) {
@@ -102,14 +138,20 @@ public class CLI implements IConversionResults {
 		return result;
 	}
 
-	
-	
+	/**
+	 * Main method.
+	 * 
+	 * @param args input arguments.
+	 */
 	public static void main(String[] args) {
 		if (args.length == 0) {
+			// If no arguments exist, launch the GUI.
 			Application.launch(Window.class, args);
 		} else {
+			// Command-line user interface only.
 			String input = null, output = null;
-			
+
+			// Get options and input parameters.
 			for (int i = 0; i < args.length; i++) {
 				Option o = new Option(args[i]);
 				if (options.containsKey(o)) {
@@ -128,19 +170,21 @@ public class CLI implements IConversionResults {
 					}
 				}
 			}
-			
+
 			if (input == null) {
 				// Only options.
 				return;
 			}
-			
+
+			// Set input and output file.
 			File inputFile = new File(input);
 			if (!inputFile.exists()) {
 				errorMessage("the input file does not exist");
 				return;
 			}
 			outputFile = output == null ? null : new File(output);
-			
+
+			// Create and run converter.
 			Converter thread = new Converter(new CLI());
 			thread.start();
 			thread.setInput(inputFile, null);
@@ -157,13 +201,16 @@ public class CLI implements IConversionResults {
 			}
 		}
 	}
-	
+
+	/**
+	 * Prints an error message.
+	 * 
+	 * @param message error message.
+	 */
 	private static void errorMessage(String message) {
 		System.out.println("\nERROR: " + message.toUpperCase() + "!\n");
 	}
-	
-	
-	
+
 	@Override
 	public void loadingInputFileError() {
 		errorMessage("there was an error loading the file");
@@ -177,7 +224,8 @@ public class CLI implements IConversionResults {
 		} else {
 			errorMessage("an error occurred while deserializing");
 			if (loaded != null) {
-				System.out.println("The following actions (print, save) will work with the extracted content of the file.");
+				System.out.println(
+						"The following actions (print, save) will work with the extracted content of the file.");
 				saveJson(loaded);
 			} else {
 				// This shouldn't happen, it's catched by the loadingInputFileError().
@@ -185,7 +233,12 @@ public class CLI implements IConversionResults {
 			}
 		}
 	}
-	
+
+	/**
+	 * Saves the resulting text (JSON) to the file or prints it to the command line.
+	 * 
+	 * @param json the resulting text in JSON format.
+	 */
 	private void saveJson(String json) {
 		if (outputFile != null) {
 			try {
@@ -199,5 +252,5 @@ public class CLI implements IConversionResults {
 			System.out.println(json);
 		}
 	}
-	
+
 }
diff --git a/project/Deserializer/src/Converter.java b/project/Deserializer/src/Converter.java
index 1e50c5d..ca5a3c3 100644
--- a/project/Deserializer/src/Converter.java
+++ b/project/Deserializer/src/Converter.java
@@ -15,19 +15,47 @@ import io.Database.DB_Messenger;
 import io.Database;
 import io.FileWorker;
 
+/**
+ * An instance of this class is a thread for converting an input file or SQL
+ * query to the resulting JSON.
+ */
 public class Converter extends Thread {
 
+	/**
+	 * The user interface that this thread created.
+	 */
 	private IConversionResults ui;
+
+	/**
+	 * True, if thread is active, otherwise false. Thread-safe variable.
+	 */
 	private AtomicBoolean active;
 
-	// P-K without E semaphore.
+	/**
+	 * "Mutex" for the producer–consumer.
+	 */
 	private Lock entryLock;
+
+	/**
+	 * Semaphore for the existence of an input requirement (producer-consumer).
+	 */
 	private Semaphore inputAvailable;
 
-	// Input.
+	/**
+	 * Variable for input file. Set by the user.
+	 */
 	private File inputFile;
+
+	/**
+	 * Variable for SQL query. Set by the user.
+	 */
 	private DB_Messenger query;
 
+	/**
+	 * Initializes instance attributes.
+	 * 
+	 * @param ui instance of the Window or CLI.
+	 */
 	public Converter(IConversionResults ui) {
 		this.ui = ui;
 		active = new AtomicBoolean(true);
@@ -35,11 +63,21 @@ public class Converter extends Thread {
 		inputAvailable = new Semaphore(0);
 	}
 
+	/**
+	 * End of the thread run.
+	 */
 	public void end() {
 		active.set(false);
 		setInput(null, null);
 	}
-	
+
+	/**
+	 * Sets the input processing request. One of the input parameters should be
+	 * null.
+	 * 
+	 * @param inputFile input file.
+	 * @param query     SQL query.
+	 */
 	public void setInput(File inputFile, DB_Messenger query) {
 		entryLock.lock();
 		this.inputFile = inputFile;
@@ -49,7 +87,15 @@ public class Converter extends Thread {
 		if (!inputAvailable.tryAcquire())
 			inputAvailable.release(); // MAX VALUE = 1!
 	}
-	
+
+	/**
+	 * Get a request to process the input.
+	 * 
+	 * @param inputFile variable for input file "passing by reference".
+	 * @param query     variable for SQL query "passing by reference".
+	 * 
+	 * @return true, when there is a request to process the input.
+	 */
 	public boolean getInput(AtomicReference<File> inputFile, AtomicReference<DB_Messenger> query) {
 		try {
 			inputAvailable.acquire();
@@ -60,7 +106,7 @@ public class Converter extends Thread {
 		entryLock.lock();
 		inputFile.set(this.inputFile);
 		query.set(this.query);
-		
+
 		this.inputFile = null;
 		this.query = null;
 		entryLock.unlock();
@@ -74,21 +120,26 @@ public class Converter extends Thread {
 		while (active.get()) {
 			AtomicReference<File> inputFile = new AtomicReference<File>();
 			AtomicReference<DB_Messenger> query = new AtomicReference<DB_Messenger>();
-			StringBuilder json = new StringBuilder();
-			boolean error = false;
 
+			// Get input data from the user.
 			if (!getInput(inputFile, query)) {
+				// If there is no data, continue.
 				continue;
 			}
 
+			// Get the byte array from the input.
 			byte array[];
 			try {
 				array = getBytes(inputFile.get(), query.get());
 			} catch (Exception e) {
+				// If an error occurs, it informs the user interface and continues.
 				ui.loadingInputFileError();
 				continue;
 			}
-			
+
+			// Deserialization of read data.
+			StringBuilder json = new StringBuilder();
+			boolean error = false;
 			try {
 				// Redirection of System.out to jdeserialize log file
 				System.setOut(FileWorker.createRedirectStream(false));
@@ -105,11 +156,21 @@ public class Converter extends Thread {
 				System.setErr(new PrintStream(new FileOutputStream(FileDescriptor.err)));
 				System.setOut(new PrintStream(new FileOutputStream(FileDescriptor.out)));
 			}
-			
+
+			// Pass the deserialization results to the UI.
 			ui.completed(error ? null : json.toString(), array == null ? null : new String(array));
 		}
 	}
 
+	/**
+	 * Retrieve data from the file or database. One parameter should always be null.
+	 * 
+	 * @param file  input file.
+	 * @param query input query.
+	 * 
+	 * @return read data in a byte array.
+	 * @throws Exception if an error occurs while retrieving data.
+	 */
 	private byte[] getBytes(File file, DB_Messenger query) throws Exception {
 		byte array[];
 		if (file != null) {
@@ -120,13 +181,15 @@ public class Converter extends Thread {
 		array = FileWorker.extractFileContent(array);
 		return array;
 	}
-	
+
 	/**
-	 * Converts the input byte buffer given by parameter into json
-	 * which is saved using the StringBuilder.
+	 * Converts the input byte buffer given by parameter into json which is saved
+	 * using the StringBuilder.
+	 * 
+	 * @param buffer byte array buffer for input data of serialized object.
+	 * @param json   StringBuilder to which will be saved the json result.
 	 * 
-	 * @param buffer  byte array buffer for input data of serialized object
-	 * @param json	  StringBuilder to which will be saved the json result
+	 * @throws Exception if an error occurred during deserialization.
 	 */
 	private void convert(byte[] buffer, StringBuilder json) throws Exception {
 		jdeserialize deserializer = new jdeserialize(buffer);
diff --git a/project/Deserializer/src/Editor.java b/project/Deserializer/src/Editor.java
index a09e7ef..204ae07 100644
--- a/project/Deserializer/src/Editor.java
+++ b/project/Deserializer/src/Editor.java
@@ -1,4 +1,3 @@
-
 import io.FileWorker;
 import javafx.concurrent.Worker;
 import javafx.scene.effect.BlendMode;
@@ -10,124 +9,190 @@ import javafx.scene.web.WebEngine;
 import javafx.scene.web.WebView;
 import netscape.javascript.JSObject;
 
+/**
+ * An instance of this class represents the editor element in the GUI.
+ */
 public class Editor {
-	
-	public static final String DEFAULT_MODE = "javascript"; // Zeek and Javascript are the best modes.
+
+	/**
+	 * Default editor mode. The best are Zeek and Javascript (when using this
+	 * deserializer).
+	 */
+	public static final String DEFAULT_MODE = "javascript";
+
+	/**
+	 * Default editor theme. The best is eclipse (when using this deserializer).
+	 */
 	public static final String DEFAULT_THEME = "eclipse";
-	
+
+	/**
+	 * A read-only text area that displays the resulting JSON.
+	 */
 	private WebView view;
+
+	/**
+	 * WebView engine.
+	 */
 	private WebEngine engine;
-	
+
+	/**
+	 * ACE editor instance in the web page.
+	 */
 	private JSObject editor;
+
+	/**
+	 * Session of the ACE editor. It is used for other settings that cannot be
+	 * specified in the editor.
+	 */
 	private JSObject session;
-	
+
+	/**
+	 * Resulting JSON.
+	 */
 	private String json;
-	
+
+	/**
+	 * WebView and WebEngine initialization.
+	 */
 	public Editor() {
 		view = new WebView();
 		view.setPrefHeight(400);
-		view.setBlendMode(BlendMode.DARKEN);
+		view.setBlendMode(BlendMode.DARKEN); // for "transparent" background.
 		view.setContextMenuEnabled(false);
-		view.setOnKeyReleased(event -> {
+		view.setOnKeyReleased(event -> { // copy does not work by default => text to clipboard.
 			if (event.isControlDown() && event.getCode() == KeyCode.C) {
 				String copy = (String) editor.call("getSelectedText");
 				if (copy != null) {
 					ClipboardContent content = new ClipboardContent();
 					content.put(DataFormat.PLAIN_TEXT, copy);
-		            Clipboard.getSystemClipboard().setContent(content);
-		        }
-		    }
+					Clipboard.getSystemClipboard().setContent(content);
+				}
+			}
 		});
-		
+
 		engine = view.getEngine();
-		engine.loadContent(getBasicHTML());
+		engine.loadContent(getBasicHTML()); // load page.
 		engine.getLoadWorker().stateProperty().addListener((observable, oldValue, newValue) -> {
 			if (newValue == Worker.State.SUCCEEDED) {
-	        	JSObject ace = (JSObject) engine.executeScript("ace");
-	            editor = (JSObject) ace.call("edit", "editor");
-	            session = (JSObject) editor.call("getSession");
-	            
-	            // Slower scrolling.
-	            editor.call("setScrollSpeed", ".1");
-	            
-	            session.call("setUseWorker", false);
-	            editor.call("setReadOnly", true);
-	            
-	            setMode(DEFAULT_MODE);
-	            setTheme(DEFAULT_THEME);
-	        }
+				JSObject ace = (JSObject) engine.executeScript("ace");
+				editor = (JSObject) ace.call("edit", "editor");
+				session = (JSObject) editor.call("getSession");
+
+				editor.call("setScrollSpeed", ".1"); // slower scrolling.
+				session.call("setUseWorker", false); // disable content checking.
+				editor.call("setReadOnly", true);
+
+				setMode(DEFAULT_MODE);
+				setTheme(DEFAULT_THEME);
+			}
 		});
 	}
-	
+
+	/**
+	 * Sets a new mode in the editor.
+	 * 
+	 * @param mode new editor mode.
+	 */
 	public void setMode(String mode) {
 		session.call("setMode", "ace/mode/" + mode);
 	}
-	
+
+	/**
+	 * Sets a new theme in the editor.
+	 * 
+	 * @param theme new editor theme.
+	 */
 	public void setTheme(String theme) {
 		editor.call("setTheme", "ace/theme/" + theme);
 	}
-	
+
+	/**
+	 * @return the using instance of the WebView.
+	 */
 	public WebView getView() {
 		return view;
 	}
-	
+
+	/**
+	 * @return the text displayed in the editor.
+	 */
 	public String getJson() {
 		return json;
 	}
-	
+
+	/**
+	 * Replaces the editor content.
+	 * 
+	 * @param json new content.
+	 */
 	public void setContent(String json) {
 		this.json = json;
 		editor.call("setValue", "");
 		editor.call("insert", json);
 	}
-	
-    private String getBasicHTML() {
-    	return "<!DOCTYPE html>" + 
-    			"<html>" + 
-    			"<head>" + 
-    			"  <style type=\"text/css\">" + 
-    			"    #editor {" + 
-    			"      margin: 0;" + 
-    			"      position: absolute;" + 
-    			"      top: 0;" + 
-    			"      bottom: 0;" + 
-    			"      left: 0;" + 
-    			"      right: 0;" + 
-    			"    }" + 
-    			"  </style>" + 
-    			"</head>" + 
-    			"<body>" +
-    			"<div id=\"editor\"></div>" +
-    			"<script src=\"" + FileWorker.getResource("/ace/ace.js") + "\"></script>" +
-    			"</body>" + 
-    			"</html>";
-    }
-    
-    // Convert HTML to string with HTML entities for insertion to JS. IT IS NO LONGER USED - only for "NICE TO HAVE".
-    private String escape(String str) {
+
+	/**
+	 * @return basic HTML page with ACE for WebView engine.
+	 */
+	private String getBasicHTML() {
+		return "<!DOCTYPE html>" + "<html>" + "<head>" + "  <style type=\"text/css\">" + "    #editor {"
+				+ "      margin: 0;" + "      position: absolute;" + "      top: 0;" + "      bottom: 0;"
+				+ "      left: 0;" + "      right: 0;" + "    }" + "  </style>" + "</head>" + "<body>"
+				+ "<div id=\"editor\"></div>" + "<script src=\"" + FileWorker.getResource("/ace/ace.js")
+				+ "\"></script>" + "</body>" + "</html>";
+	}
+
+	/**
+	 * Converts classic text with HTML tags to the correct HTML (critical characters
+	 * replaced by HTML entities). For insertion to JS. IT IS NO LONGER USED - only
+	 * for "NICE TO HAVE".
+	 * 
+	 * @param str text that is half plain text ('\n', '\t', etc.) and half html.
+	 * 
+	 * @return correct HTML with HTML entities.
+	 */
+	@SuppressWarnings(value = { "unused" })
+	private String escape(String str) {
 		StringBuilder builder = new StringBuilder();
 		char strArray[] = str.toCharArray();
 		for (int i = 0; i < strArray.length; i++) {
 			char c = strArray[i];
 			switch (c) {
-				case '\'': builder.append("&#39;"); break;
-				case '<': builder.append("&lt;"); break;
-				case '>': builder.append("&gt;"); break;
-				case '&': builder.append("&amp;"); break;
-				case '"': builder.append("&quot;"); break;
-				case '\n': builder.append("<br/>"); break;
-				case '\t': builder.append("&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;"); break;
-				case ' ': builder.append("&nbsp;"); break;
-				case (char) 13: break;
-				default:
-					if (c < 128) {
-						builder.append(c);
-					} else {
-						builder.append("&#").append((int) c).append(";");
-					}
+			case '\'':
+				builder.append("&#39;");
+				break;
+			case '<':
+				builder.append("&lt;");
+				break;
+			case '>':
+				builder.append("&gt;");
+				break;
+			case '&':
+				builder.append("&amp;");
+				break;
+			case '"':
+				builder.append("&quot;");
+				break;
+			case '\n':
+				builder.append("<br/>");
+				break;
+			case '\t':
+				builder.append("&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;");
+				break;
+			case ' ':
+				builder.append("&nbsp;");
+				break;
+			case (char) 13:
+				break;
+			default:
+				if (c < 128) {
+					builder.append(c);
+				} else {
+					builder.append("&#").append((int) c).append(";");
+				}
 			}
 		}
 		return builder.toString();
 	}
-    
+
 }
diff --git a/project/Deserializer/src/IConversionResults.java b/project/Deserializer/src/IConversionResults.java
index f636389..2a71f32 100644
--- a/project/Deserializer/src/IConversionResults.java
+++ b/project/Deserializer/src/IConversionResults.java
@@ -1,7 +1,25 @@
 
+/**
+ * The interface, which is implemented by Window and CLI, is used to transfer
+ * results from the conversion thread to the user interface (UI).
+ */
 public interface IConversionResults {
 
+	/**
+	 * This method is used when an input read error occurs.
+	 */
 	public void loadingInputFileError();
+
+	/**
+	 * 
+	 * This method is used to transfer the resulting JSON to the user interface. It
+	 * also transmits the extracted input content (file, query).
+	 * 
+	 * @param json   the resulting JSON. It is null when a jdeserialize error
+	 *               occurs.
+	 * @param loaded extracted input content. It is null if an input read error
+	 *               occurs.
+	 */
 	public void completed(String json, String loaded);
-	
+
 }
diff --git a/project/Deserializer/src/Report.java b/project/Deserializer/src/Report.java
index 1258b54..9f8ba34 100644
--- a/project/Deserializer/src/Report.java
+++ b/project/Deserializer/src/Report.java
@@ -4,34 +4,64 @@ import javafx.geometry.Rectangle2D;
 import javafx.scene.control.Alert;
 import javafx.scene.control.Alert.AlertType;
 import javafx.stage.Screen;
-import javafx.stage.Window;
 
+/**
+ * Report is class for creating dialog windows (error messages, information
+ * messages, confirmation of something).
+ */
 public class Report {
-	
+
+	/**
+	 * Preferred window height.
+	 */
 	private static final int HEIGHT = 200;
+
+	/**
+	 * Preferred window width.
+	 */
 	private static final int WIDTH = 500;
 
+	/**
+	 * To center dialog window on the screen.
+	 * 
+	 * @param alert dialog window.
+	 */
 	private static void setPosition(Alert alert) {
-		// For Java 8.
+		// For Java 8:
 		if (StageHelper.getStages() != null && StageHelper.getStages().size() != 0) {
 			if (Screen.getPrimary() != null && Screen.getPrimary().getVisualBounds() != null) {
 				Rectangle2D primScreenBounds = Screen.getPrimary().getVisualBounds();
 				alert.setX((primScreenBounds.getWidth() - WIDTH - 20) / 2);
-		        alert.setY((primScreenBounds.getHeight() - HEIGHT - 20) / 3);
+				alert.setY((primScreenBounds.getHeight() - HEIGHT - 20) / 3);
 			}
 			alert.initOwner(StageHelper.getStages().get(StageHelper.getStages().size() - 1));
 		}
-		/* For Java 11.
-		if (Window.getWindows() != null && Window.getWindows().size() != 0) {
-			if (Screen.getPrimary() != null && Screen.getPrimary().getVisualBounds() != null) {
-				Rectangle2D primScreenBounds = Screen.getPrimary().getVisualBounds();
-				alert.setX((primScreenBounds.getWidth() - WIDTH - 20) / 2);
-		        alert.setY((primScreenBounds.getHeight() - HEIGHT - 20) / 3);
-			}
-			alert.initOwner(Window.getWindows().get(Window.getWindows().size() - 1));
-		}*/
+		/*
+		 * For Java 11:
+		 * 
+		 * import javafx.stage.Window;
+		 * 
+		 * if (Window.getWindows() != null && Window.getWindows().size() != 0) {
+		 *     if (Screen.getPrimary() != null && Screen.getPrimary().getVisualBounds() != null) {
+		 *         Rectangle2D primScreenBounds = Screen.getPrimary().getVisualBounds();
+		 *         alert.setX((primScreenBounds.getWidth() - WIDTH - 20) / 2);
+		 *         alert.setY((primScreenBounds.getHeight() - HEIGHT - 20) / 3);
+		 *     }
+		 *     alert.initOwner(Window.getWindows().get(Window.getWindows().size() - 1));
+		 * }
+		 */
 	}
-	
+
+	/**
+	 * This method creates dialog windows.
+	 * 
+	 * @param type    dialog window type.
+	 * @param title   window title.
+	 * @param header  header of the window content.
+	 * @param content body of the window content.
+	 * 
+	 * @return created dialog windows.
+	 */
 	private static Alert createAlert(AlertType type, String title, String header, String content) {
 		Alert alert = new Alert(type);
 		alert.setResizable(true);
@@ -42,15 +72,38 @@ public class Report {
 		setPosition(alert);
 		return alert;
 	}
-	
+
+	/**
+	 * Error dialog.
+	 * 
+	 * @param title   window title.
+	 * @param header  header of the window content.
+	 * @param content body of the window content.
+	 */
 	public static void error(String title, String header, String content) {
 		createAlert(AlertType.WARNING, title, header, content).showAndWait();
 	}
-	
+
+	/**
+	 * Information dialog.
+	 * 
+	 * @param title   window title.
+	 * @param header  header of the window content.
+	 * @param content body of the window content.
+	 */
 	public static void info(String title, String header, String content) {
 		createAlert(AlertType.INFORMATION, title, header, content).showAndWait();
 	}
-	
+
+	/**
+	 * Confirmation dialog.
+	 * 
+	 * @param title   window title.
+	 * @param header  header of the window content.
+	 * @param content body of the window content.
+	 * 
+	 * @return true if OK was clicked, otherwise false.
+	 */
 	public static boolean confirm(String title, String header, String content) {
 		Alert alert = createAlert(AlertType.CONFIRMATION, title, header, content);
 		alert.showAndWait();
@@ -60,5 +113,5 @@ public class Report {
 			return false;
 		}
 	}
-	
+
 }
